#######################################################################
#          Licensed Materials - Property of IBM                       #
#          "Restricted Materials of IBM"                              #
#          5748-T15                                                   #
#          (C) Copyright IBM Corp. 2006                               #
#          All Rights Reserved                                        #
#          US Government Users Restricted Rights - Use, duplication   #
#          or disclosure restricted by GSA ADP Schedule Contract      #
#          with IBM Corp.                                             #
#######################################################################
#  This file is provided on an "as is" basis.  There are no           #
#  warranties, express or implied, including the implied warranties   #
#  of merchantability and fitness for a particular purpose.           #
#  IBM has no obligation to provide service, defect correction, or    #
#  any maintenance for the file.  IBM has no obligation to supply     #
#  any updates or enhancements for the file to you even if such are   #
#  or later become available.                                         #
#######################################################################
#  Change History                                                     #
#                                                                     #
#                                                                     #
#                                                                     #
#######################################################################

###############################################################################
# Define the 4 character base name for this shared object or executable
###############################################################################

APP := QKP1
APP_ENTRY := QKP1
APP_EXPORT := ENTRY
TPF_DRIVER := kpts

################################################################################
# Override default Optimization
################################################################################

#CXXFLAGS_QKP1 := -O0

################################################################################
# Define the module is to reside in the 31bit CRPA
################################################################################

#LDFLAGS_QKP1 := -Xlinker --defsym -Xlinker CGCC_31BIT=0

################################################################################
# Define the envs needed to build this module, in the order of precedence
################################################################################

maketpf_env := drvs
maketpf_env += base_rt
maketpf_env += system

################################################################################
# Define the libs needed to link (-l)
# - how do we handle including a file of all TPF libs?
# - do we have to remove name of lib from "all list" when building name?
################################################################################

#LIBS :=

################################################################################
# Segments to be compiled with gcc compiler
################################################################################

CXX_SRC := qkp100.cpp

################################################################################
# Segments to be assembled
################################################################################

#ASMFLAGS_MAK =

################################################################################
# Include the maketpf.rules
################################################################################

include maketpf.rules
