         PRINT NOGEN
         BEGIN NAME=QKP3,IBM=YES
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
         SYSEQC
FILEADDR     EQU   EBX000,8        TEMP STOR FILE ADDRESS
         EV0BK
TAG_DATA     EQU   EBW000,4        TAG DATA MOVED TO LAST-FILED-BY
KPT_PARM     EQU   EBW004          KEYPOINT TO BE TAGGED
KPT_PARMA    EQU   EBW005          BLANK FOR WTOPC DISPLAY
TARGET_PROC  EQU   EBW006          CHAR PROCESSOR
PROC_ORD     EQU   EBW007,2        PROCESSOR ORDINAL
********************************
* LOCATION AND IMAGE_NO MUST
* STAY TOGETHER. THEY ARE A KEY
********************************
LOCATION     EQU   EBW009          TARGET AREA
KSA          EQU   B'10000000'     KSA INDICATOR
KBA          EQU   B'01000000'     KBA INDICATOR
KLGFBA       EQU   B'00100000'     KLGFBA INDICATOR
IMAGE_NO     EQU   EBW010          TARGET IMAGE NUMBER
********************************
*
VERBOSE      EQU   EBW011          VERBOSE INDICATOR
*
FACETYPE     EQU   EBW012,8        SYMBOLIC FACE TYPE
ORDINAL      EQU   EBW020,8        KEYPOINT ORDINAL
FADDR        EQU   EBW028,8        KEYPOINT FILE ADDRESS
RETCODE      EQU   EBW036          RETURN CODE TO CALLER
RET_OK       EQU   0               GOOD RETURN
RET_FAIL     EQU   1               REQUEST FAILED
RET_INVALID  EQU   2               REQUEST INVALID
*
SIPDATA_LEN  EQU   37              LENGTH OF ABOVE DATA
         CZ1CP
***********************************************************************
*
* THIS SEGMENT IS ENTERED FROM QKP0 TO MODIFY THE LAST_FILED_BY
* FIELD OF THE REQUESTED KEYPOINT ON THE REQUESTED REMOTE PROCESSOR.
*
* INPUT REQUIRMENTS
*        EBW008 - C'SEND' IF ENTERED FROM QKP0
*

*
* OUTPUT REQUIREMENTS
*        THIS SEGMENT WILL SEND A REQUEST TO ITSELF ON THE REQUESTED
*        PROCESSOR IN THE COMPLEX TO TAG THE REQUESTED KEYPOINT.
***********************************************************************
         MVI   RETCODE,RET_OK       INITIALIZE RETURN
         GETCC D2,L1
         LGF   R14,CE1CR2           LOAD BASE
         STMG   R0,R7,0(R14)        SAVE REGS
*
         PI1DT REG=R7
         CINFC R,CMMPID,F
         LR    R7,R14
*
        SPACE 2
*                           SCAN KEYPT NAME TABLE FOR MATCH
         LA    R6,TABLITML             INCREMENT FOR BXH
         LA    R5,KEYPTABL-TABLITML    START OF TBL LESS INCR
         LA    R7,TABLEND              ADDR OF LAST BYTE OF TBL
TBLSCAN  DS    0H
         BXH   R5,R6,ERR_NAME          TABLE END, SEND ERROR MESSAGE
         CLC   KPTNAM(1,R5),KPT_PARM   KEYPOINT IN TABLE ?
         BNE   TBLSCAN                 NO - TRY AGAIN
*                                      MATCH FOUND
         CX0CK REG=R4          06-CTKX
         CINFC R,CMMCTKX,F             06-CTKX ADDR
         LR    R4,R14
         SR    R15,R15
         IC    R15,KPTIDX(,R5)         GET KEYPT INDEX
            DROP  R4
            USING CX0CK,R3
         LA    R3,CX0ENA               CTKX DESCRIPTOR ITEM LENGTH
         MR    R2,R15                  * KEYPT INDEX NBR + BASE
         AR    R3,R4                   = KEYPT DESCR SLOT ADDR
        SPACE 2
   IF CX0IN1,MASK,INDBSS,=,1           IF KEYPOINT SS UNIQUE...
   THEN
*         DO NOTHING
   ELSE                               AND IF KEYPT BSS UNIQUE
      IF CE1DBI,^=,BSSID              DBI FOR BSS...?
      THEN
         CINFC R,CMMCTKX,BSS=YES       NO...GET BASE OF CTKX IN BSS
         LR    R4,R14
      ELSE
*        DO NOTHING                    DBI IS OK
      ENDIF
   ENDIF
        SPACE 2
         DROP  R3
         USING CX0CK,R4
         LA    R3,CX0END          LENGTH OF CTKX KEYPT ITEM
         MR    R2,R15             * KEYPT INDEX NMBER = SLOT W/ F.A.
       SPACE  2
         LA     R5,CX0FAR(R3)        FILE ADDRESS
         FA4X4C ACTION=4TO8,FA4=(R5),FA8=FILEADDR
*---------------------------------------------------------------------*
*        Convert file address with ESFAC                              *
*---------------------------------------------------------------------*
CFAICVT DS    0H
        LA    R5,FILEADDR        Set up address to convert
        ESFAC ,ADDR=(R5),EBX008  Convert FARF address
        BNZ   KPFIND_ERROR       Address did not convert
        DCTSON
        USING SONFMT,R5
        LA    R5,EBX008
        MVC   ORDINAL,SONXORD    SAVE ORDIAL
        CLC   SONRTYP,=A(#KEYPT) IS THIS A NORMAL SIZED KEYPT?
        JNE   SUPERSIZED
        DROP R4,R5
        IDSFCZ REG=R5
        XR    R14,R14            CLEAR COUNT
        LA    R15,KPT4K_TBL        POINT BASE
        LA    R14,KPT4K_ITM_CNT    GET TABLE COUNT
KPT4K_ITM_LOOP  DS 0H
        CLC   0(2,R15),LOCATION  IS THIS THE ONE WE WANT?
        JE    GOT_KPT4K_FACE       YES..
        LA    R15,KPT4K_ITM_LEN(,R15)  BUMP TO NEXT ITEM
        BCT   R14,KPT4K_ITM_LOOP   NEXT
        BNZ   KPFIND_ERROR       Address did not convert           ?
GOT_KPT4K_FACE  DS 0H
        MVC   IFCZREC,2(R15)
        J     GET_ORD
*
SUPERSIZED DS 0H
        IDSFCZ REG=R5
        XR    R14,R14            CLEAR COUNT
        LA    R15,KPT_TBL        POINT BASE
        LA    R14,KPT_ITM_CNT    GET TABLE COUNT
KPT_ITM_LOOP  DS 0H
        CLC   0(2,R15),LOCATION  IS THIS THE ONE WE WANT?
        JE    GOT_KPT_FACE       YES..
        LA    R15,KPT_ITM_LEN(,R15)  BUMP TO NEXT ITEM
        BCT   R14,KPT_ITM_LOOP   NEXT
        BNZ   KPFIND_ERROR       Address did not convert           ?
GOT_KPT_FACE  DS 0H
        MVC   IFCZREC,2(R15)     MOVE SKELETON FACE-ID
        MVC   IFCZREC+4(1),KPT_PARM MOVE IN KPT LETTER
*
GET_ORD DS    0H
        MVC   IFCZOR8,ORDINAL
        MVC   IFCZPRO,PROC_ORD
        XC    IFCZOUT,IFCZOUT

        CLI   TARGET_PROC,X'00'   PROC REQUEST
        JE    NOT_PROC
*---------------------------------------------------------------------*
*        PROC REQUEST                                                 *
*---------------------------------------------------------------------*
        FACZC PARMS=R5,DEFPROC=NO,TYPE=FACS
        CLI   IFCZRET,IFCZNRM
        JNE   KPFIND_ERROR       Cannot tag
        J     GOTFA
*---------------------------------------------------------------------*
*        NON_PROC REQUEST                                             *
*---------------------------------------------------------------------*
NOT_PROC DS    0H
        FACZC PARMS=R5,DEFPROC=YES,TYPE=FACS
        CLI   IFCZRET,IFCZNRM
        JNE   KPFIND_ERROR       Cannot tag
GOTFA   DS    0H
        DECBC FUNC=CREATE,DECB=(R7)
        IDECB REG=R7
        MVC   IDECRID,=C'CK'      SET RECID
        XC    IDECRCC(2),IDECRCC ZERO THE OTEHR INDS
        MVC   IDECFA,IFCZAD8      SET FA
        DROP  R5
        CLI   VERBOSE,0
        BE    SKIPMSGFA
        WTOPC TEXT='KPT FA= ................',SUB=(HEXBA,IDECFA)
SKIPMSGFA DS 0H
        FIWHC ,DECB=(R7),KPFIWHC_ERROR    FIND THE KPT
        L    R14,IDECCRW          SET THE BASE
        MVC  4(4,R14),TAG_DATA    TAG THE KPT
        FILNC DECB=(R7),TAG=N       FILE THE KPT
        WAITC KP_FILE_ERROR       CHECK FOR ERROR
        RCUNC DECB=(R7)
        DECBC FUNC=RELEASE,DECB=(R7)
        B    REPLY_RETURN         OUTTA HERE
KP_FILE_ERROR DS 0H
        CLI   VERBOSE,0
        BE    SKIPMSG5
        WTOPC TEXT='KPT .. FILE ERROR',SUB=(CHARA,KPT_PARM)
SKIPMSG5 DS 0H
        MVI   RETCODE,RET_FAIL
        B     REPLY_RETURN

KPFIWHC_ERROR DS 0H
        LEVTA DECB=(R7),NOTUSED=SKIP_RELEASE
        RCUNC DECB=(R7)
SKIP_RELEASE DS 0H
        CLI   VERBOSE,0
        BE    SKIPMSGA
        MVI   KPT_PARMA,X'40' BLANK FOR DISPLAY
        WTOPC TEXT='KPT .. TAG FIWHC ERROR',SUB=(CHARA,KPT_PARM)
SKIPMSGA DS 0H
        MVI   RETCODE,RET_FAIL
        B    REPLY_RETURN

KPFIND_ERROR DS 0H
        CLI   VERBOSE,0
        BE    SKIPMSG6
        MVI   KPT_PARMA,X'40' BLANK FOR DISPLAY
        WTOPC TEXT='KPT .. TAG FIND ERROR',SUB=(CHARA,KPT_PARM)
SKIPMSG6 DS 0H
        MVI   RETCODE,RET_FAIL
        B    REPLY_RETURN

ERR_NAME DS 0H
        CLI   VERBOSE,0
        BE    SKIPMSG7
        WTOPC TEXT='KPT .. INV KPT',SUB=(CHARA,KPT_PARM)
SKIPMSG7 DS 0H
        MVI   RETCODE,RET_FAIL

REPLY_RETURN DS 0H
         LGF    R14,CE1CR2           LOAD BASE
         LMG    R0,R7,0(R14)         RESTORE REGS
         RELCC  D2
         BACKC
        EJECT

***********************************************************************
*        TABLE OF FACE ID's for KPT AREAS                             *
***********************************************************************
*             AREA, IMAGE, FACEID
KPT_TBL EQU   *
        DC    AL1(X'00'),X'00',CL8'#CTK-'
KPT_ITM_LEN      EQU *-KPT_TBL
        DC    AL1(KBA),X'00',CL8'#CTK-B'
        DC    AL1(KLGFBA),X'00',CL8'#CTK-LGF'
        DC    AL1(KSA),X'01',CL8'#CTK-1'
        DC    AL1(KSA),X'02',CL8'#CTK-2'
        DC    AL1(KSA),X'03',CL8'#CTK-3'
        DC    AL1(KSA),X'04',CL8'#CTK-4'
        DC    AL1(KSA),X'05',CL8'#CTK-5'
        DC    AL1(KSA),X'06',CL8'#CTK-6'
        DC    AL1(KSA),X'07',CL8'#CTK-7'
        DC    AL1(KSA),X'08',CL8'#CTK-8'
KPT_ITM_END   EQU   *
KPT_ITM_CNT   EQU (KPT_ITM_END-KPT_TBL)/KPT_ITM_LEN
*
KPT4K_TBL EQU   *
        DC    AL1(X'00'),X'00',CL8'#KEYPT'
KPT4K_ITM_LEN      EQU *-KPT4K_TBL
        DC    AL1(KBA),X'00',CL8'#KBA'
        DC    AL1(KLGFBA),X'00',CL8'#KLGFBA'
        DC    AL1(KSA),X'01',CL8'#KSA1'
        DC    AL1(KSA),X'02',CL8'#KSA2'
        DC    AL1(KSA),X'03',CL8'#KSA3'
        DC    AL1(KSA),X'04',CL8'#KSA4'
        DC    AL1(KSA),X'05',CL8'#KSA5'
        DC    AL1(KSA),X'06',CL8'#KSA6'
        DC    AL1(KSA),X'07',CL8'#KSA7'
        DC    AL1(KSA),X'08',CL8'#KSA8'
KPT4K_ITM_END   EQU   *
KPT4K_ITM_CNT   EQU (KPT4K_ITM_END-KPT4K_TBL)/KPT4K_ITM_LEN
*---------------------------------------------------------------------*
*                                                                     *
* TABLE OF VALID KEYPOINTS                                            *
*        THIS TABLE WILL CONTAIN A NUMBER OF ENTRIES EQUAL TO THE     *
*        NUMBER OF KEYPOINTS.  EACH ENTRY WILL CONSIST OF A           *
*        KEYPOINT NAME AND THE KEYPOINT'S INDEX (FROM CTKX).          *
*                                                                     *
*---------------------------------------------------------------------*
        SPACE 2
KEYPTABL DS    0D
         DC    AL1(CXCTKA)         KEYPT INDEX
         DC    C'A'                KEYPT NAME
        SPACE 1
ITEMEND  DC    AL1(CXCTKB)         KEYPT INDEX
KYPTIDT  DC    C'B'                KEYPT NAME
        SPACE 1
         DC    AL1(CXCTKC)         KEYPT INDEX
         DC    C'C'                KEYPT NAME
        SPACE 1
         DC    AL1(CXCTKD)         KEYPT INDEX
         DC    C'D'                KEYPT NAME
        SPACE 1
         DC    AL1(CXCTKE)         KEYPT INDEX
         DC    C'E'                KEYPT NAME
        SPACE 1
         DC    AL1(CXCTKI)         KEYPT INDEX
         DC    C'I'                KEYPT NAME
        SPACE 1
         DC    AL1(CXCTKM)         KEYPT INDEX
         DC    C'M'                KEYPT NAME
        SPACE 1
         DC    AL1(CXCTKV)         KEYPT INDEX
         DC    C'V'                KEYPT NAME
        SPACE 1
         DC    AL1(CXCTK0)         KEYPT INDEX
         DC    C'0'                KEYPT NAME
        SPACE 1
         DC    AL1(CXCTK1)         KEYPT INDEX
         DC    C'1'                KEYPT NAME
        SPACE 1
         DC    AL1(CXCTK2)         KEYPT INDEX
         DC    C'2'                KEYPT NAME
         SPACE 1
         DC    AL1(CXCTK3)         KEYPT INDEX
         DC    C'3'                KEYPT NAME
        SPACE 1
         DC    AL1(CXCTK4)         KEYPT INDEX
         DC    C'4'                KEYPT NAME
        SPACE 1
         DC    AL1(CXCTK5)         KEYPT INDEX
         DC    C'5'                KEYPT NAME
        SPACE 1
         DC    AL1(CXCTK6)         KEYPT INDEX
         DC    C'6'                KEYPT NAME
        SPACE 1
         DC    AL1(CXCTK9)         KEYPT INDEX
         DC    C'9'                KEYPT NAME
TABLEND  EQU   *-1
TABLITML EQU   ITEMEND-KEYPTABL    ITEM LENGTH
KPTNAM   EQU   KYPTIDT-ITEMEND     DISPL TO KEYPT NAME IN ITEM
KPTIDX   EQU   ITEMEND-ITEMEND     DISPL TO KEYPT INDX IN ITEM

BSSID    DC    AL2(CPBSSID)        MUST BE ON A HALFWORD
         EJECT
         FINIS
         END
